#include <ctype.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <sys/poll.h>
#include <assert.h>
#include <errno.h>

#include "totutil.h"

// i'm not afraid to do it

i_argstream::i_argstream (int f, unsigned int t)
{
	fd = f;
	timeout = t;
	ihave = iof = 0;
}

bool i_argstream::readbuf ()
{
	pollfd pfd = { fd, POLLIN, 0 };
	int i;

	i = p_poll (&pfd, 1, timeout);

	if (i != 1) return false;

	ihave = p_read (fd, ibuf, ARGSTREAM_BUFFER);
	iof = 0;

#ifdef DEBUG
DPRINTF (DB_SLOT1, "_____read %i byts\n", ihave);
for (i=0;i<ihave;i++)
DPRINTF (DB_SLOT5, (isprint(ibuf[i]))?"%c":" [%d] ", ibuf [i]);
#endif

	return ihave > 0;
}

bool i_argstream::peek ()
{
	return iof < ihave;
}

int i_argstream::getarg (char *b, int ml)
{
	int bp = 0;

	if (ihave == 0 && !readbuf ()) return GETARG_EOF;

	while (iof < ihave && bp < ml)
		if ((b [bp++] = ibuf [iof++]) == 0) break;

	if (bp && b [bp - 1] == 0) {
DPRINTF (DB_SLOT1, "<<<-------Got Argument [%s]\n", b);
		return GETARG_OK;
	}

	if (bp == ml)
		return GETARG_TOOLONG;

	ihave = 0;
	return getarg (b + bp, ml - bp);
}

int i_argstream::getdata (char *b, int l)
{
	// client needs that. no arguments after data...
	if (l == 0) return GETARG_OK;

	int d = ihave - iof, c;

	if (d) memcpy (b, ibuf + iof, d);

	while (d < l)
		if ((c = p_read (fd, b + d, l - d)) <= 0)
			return GETARG_EOF;
		else d += c;

	return GETARG_OK;
}

//******************************************************
// Not really a stream. The entire buffer is constructed
// and eventually flushed with writeout() - which resets
// the buffer to empty.
//******************************************************

o_argstream::o_argstream ()
{
	release = false;
	data = NULL;
	max = 0;
}

void o_argstream::setmax (int m)
{
	release = true;
	data = new char [max = m];
	have = 0;
}

o_argstream::o_argstream (int m)
{
	setmax (m);
}

o_argstream::o_argstream (char *d, int m)
{
	data = d;
	max = m;
	have = 0;
	release = false;
}

void o_argstream::putarg (char *s)
{
DPRINTF (DB_SLOT1, "-->>>>Sending [%s]\n", s);
	strcpy (data + have, s);
	have += strlen (s) + 1;
}

void o_argstream::putarg (char *s1, char *s2)
{
	strcpy (data + have, s1);
	have += strlen (s1);
	putarg (s2);
}

void o_argstream::putarg (unsigned int i)
{
	char tmp [10];
	sprintf (tmp, "%x", i);
	putarg (tmp);
}

void o_argstream::putarg (char *s, unsigned int i)
{
	strcpy (data + have, s);
	have += strlen (s);
	putarg (i);
}

void o_argstream::putarg (cryptotype i)
{
	char tmp [10];
	sprintf (tmp, CRYPTOFORMAT, i);
	putarg (tmp);
}

void o_argstream::putMsgID (unsigned int s, unsigned int r)
{
	char tmp [20];
	sprintf (tmp, "%x.%x", s, r);
	putarg (tmp);
}

void o_argstream::putzero ()
{
	data [have++] = 0;
}

bool o_argstream::writeout (int fd)
{
	bool r = write (fd, data, have) == have;
	have = 0;
	return r;
}

o_argstream::~o_argstream ()
{
	if (data && release) delete [] data;
}
